/* TraverseUpButton.java

	Purpose:
		
	Description:
		
	History:
		Mon Dec 02 12:42:37 CST 2019, Created by rudyhuang

Copyright (C) 2019 Potix Corporation. All Rights Reserved.
*/
package org.zkoss.chart;

import org.zkoss.chart.util.DynamicalAttribute;

/**
 * Options for the button appearing when traversing down in a diagram.
 *
 * @author rudyhuang
 * @since 7.2.1.0
 */
public class TraverseUpButton extends Optionable {
	private enum Attrs implements PlotAttribute, DynamicalAttribute {
		position
	}

	public TraverseUpButton() {
	}

	/**
	 * Construct with a position.
	 */
	public TraverseUpButton(Position position) {
		setPosition(position);
	}

	/**
	 * Returns the position of the button, if any.
	 * Otherwise, create a new one.
	 */
	public Position getPosition() {
		Position position = (Position) getAttr(Attrs.position);
		if (position == null) {
			position = new Position();
			setPosition(position);
		}
		return position;
	}

	/**
	 * Sets the position of the button, if any.
	 * Otherwise, create a new one.
	 */
	public void setPosition(Position position) {
		setAttr(Attrs.position, position);
	}
}
