/* FromToWeightModel.java

	Purpose:

	Description:

	History:
		Tue Dec 10 15:15:35 CST 2019, Created by rudyhuang

Copyright (C) 2019 Potix Corporation. All Rights Reserved.
*/
package org.zkoss.chart.model;

/**
 * A (from, to, weight) chart data model.
 *
 * @author rudyhuang
 * @since 7.2.1.0
 */
public interface FromToWeightModel extends FromToModel {
	/**
	 * Get weight value of a specified series and data index.
	 * @param series the series.
	 * @param index the data index.
	 */
	Number getWeight(Comparable<?> series, int index);

	/**
	 * Append a (from, to, weight) into a series.
	 * @param series the series.
	 * @param from the from value.
	 * @param to the to value.
	 * @param weight the weight value.
	 */
	void addValue(Comparable<?> series, String from, String to, Number weight);

	/**
	 * Add a (from, to, weight) into a series at the specified index.
	 * @param series the series.
	 * @param from the from value.
	 * @param to the to value.
	 * @param weight the weight value.
	 * @param index the data index.
	 */
	void addValue(Comparable<?> series, String from, String to, Number weight, int index);

	/**
	 * Replace a (from, to, weight) into a series at the specified index.
	 * @param series the series.
	 * @param from the from value.
	 * @param to the to value.
	 * @param weight the weight value.
	 * @param index the data index.
	 */
	void setValue(Comparable<?> series, String from, String to, Number weight, int index);
}
