/* ColumnRangePlotOptions.java

	Purpose:
		
	Description:
		
	History:
		Thu, Jan 16, 2014  3:58:08 PM, Created by RaymondChao

Copyright (C) 2014 Potix Corporation. All Rights Reserved.

 */
package org.zkoss.chart.plotOptions;

import org.zkoss.chart.PlotAttribute;
import org.zkoss.chart.util.DynamicalAttribute;

/**
 * An option for column range plot
 * 
 * <p>
 * All the options in this class support {@link DynamicalAttribute}.
 * @author RaymondChao
 */
public class ColumnRangePlotOptions extends SeriesPlotOptions {
	private enum Attrs implements PlotAttribute, DynamicalAttribute {
		depth
	}

	@Override
	protected DataLabels newDataLabels() {
		return new RangeDataLabels();
	}

	@Override
	public RangeDataLabels getDataLabels() {
		return (RangeDataLabels) super.getDataLabels();
	}

	/**
	 * Returns the depth of the columns in a 3D column range chart.
	 * <p>
	 * Default: 25
	 */
	public Number getDepth() {
		return getAttr(Attrs.depth, 25).asNumber();
	}

	/**
	 * Sets the depth of the columns in a 3D column range chart.
	 */
	public void setDepth(Number depth) {
		setAttr(Attrs.depth, depth);
	}
}